package sillysagiri.scene;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

import sillysagiri.BMF;
import sillysagiri.Sagiri;
import sillysagiri.Scene;
import sillysagiri.Utils;

public class Instruction extends Scene {

  private final int STATE_TAB_KEYS  = 0;
  private final int STATE_TAB_MOVE  = 1;
  private final int STATE_TAB_ITEMS = 2;
  private final int STATE_TAB_SKILL = 3;

  private byte state_tab = 0;
  private byte state_page = 0;

  private BMF bmf_black;
  private BMF bmf_lime;
  private BMF bmf_blue;

  private Image img_loop;
  private Image img_out;
  private Image img_keypad;
  private Image img_arrow;

  private String[] str_list1;
  private String[] str_list2;

  public void Preload() {
    try
    {
      bmf_black = BMF.Create("/silly/bmf/nds12_0.silly.gz", "/silly/bmf/nds12.fnt", 0xff000000);
      bmf_lime = BMF.Create("/silly/bmf/nds12_0.silly.gz", "/silly/bmf/nds12.fnt", 0xffB6FF00);
      bmf_blue = BMF.Create("/silly/bmf/onds12_0.silly.gz", "/silly/bmf/onds12.fnt", 0xff00dbff);

      img_loop = Image.createImage("/m_2.png");
      img_keypad = Image.createImage("/bH.png");
      img_out = Image.createImage("/out.png");
      img_arrow = Image.createImage("/i_0.png");
    }
    catch(Exception e)
    {
      sagiri.Set_Scene(new DeathError(e));
    }
  }

  public void Destroy() {
  }

  public void Update(long dt, Graphics g) {
    Utils.Clear_Screen(g, 255, 108, 0);

    int loopCount = (int)Math.ceil((float)Utils.GetScreenHeight()/img_loop.getHeight());
      for (int i = 0; i<loopCount; i++)
        g.drawImage(img_loop, 0, i*img_loop.getHeight(), Graphics.LEFT | Graphics.TOP);

    int size_header = (int)(bmf_blue.lineHeight*1.5);
    g.setColor(109, 0, 0);
    g.fillRect(5, 5, Utils.GetScreenWidth()-10, size_header);

    bmf_blue.DrawEx(g, "Instructions", 10, (size_header/2)+5, Graphics.LEFT | Graphics.VCENTER);
    g.drawImage(img_out, Utils.GetScreenWidth()-10, (size_header/2)+5, Graphics.RIGHT|Graphics.VCENTER);

    g.fillRect(5, size_header+7, Utils.GetScreenWidth()-10, size_header);

    int cursory = size_header+7 + (size_header/2);
    g.drawRegion(
      img_arrow, 
      0, 0, 7, 11,
      Sprite.TRANS_NONE,
      7, cursory,
      Graphics.VCENTER | Graphics.LEFT);

    g.drawRegion(
      img_arrow, 
      7, 0, 7, 11,
      Sprite.TRANS_NONE,
      Utils.GetScreenWidth()-7, cursory,
      Graphics.VCENTER | Graphics.RIGHT);

    short[] size_t1 = bmf_black.Measure("Keys");
    short[] size_t2 = bmf_black.Measure("Movement");
    short[] size_t3 = bmf_black.Measure("Items");
    short[] size_t4 = bmf_black.Measure("Skill");
    int size_t = size_t1[0] + size_t2[0] + size_t3[0] + size_t4[0];
    int separator = ((Utils.GetScreenWidth()-10) - size_t - 38) / 3;
    short[] size_h = bmf_black.Measure("KeysMovementItemsSkill");
    // cursory = (size_header+7) + 2;
    cursory = (size_header+7) + (size_header-size_h[1])/2;
    int cursorx = 24;

    if (state_tab == 0) bmf_lime.Draw(g, "Keys", cursorx, cursory);
    else bmf_black.Draw(g, "Keys", cursorx, cursory);
      
    if (state_tab == 1) bmf_lime.Draw(g, "Movement", cursorx+=size_t1[0]+separator, cursory);
    else bmf_black.Draw(g, "Movement", cursorx+=size_t1[0]+separator, cursory);
      
    if (state_tab == 2) bmf_lime.Draw(g, "Items", cursorx+=size_t2[0]+separator, cursory);
    else bmf_black.Draw(g, "Items", cursorx+=size_t2[0]+separator, cursory);
      
    if (state_tab == 3) bmf_lime.Draw(g, "Skill", cursorx+=size_t3[0]+separator, cursory);
    else bmf_black.Draw(g, "Skill", cursorx+=size_t3[0]+separator, cursory);
      
    switch (state_tab) {
      case STATE_TAB_KEYS:
      {
        g.drawImage(img_keypad, Utils.GetScreenWidth()/2, Utils.GetScreenHeight()/2, Graphics.VCENTER | Graphics.HCENTER);
        
        cursorx = (Utils.GetScreenWidth()/2) - img_keypad.getWidth()/2 - 3;
        cursory = 116;
        g.drawLine(cursorx, cursory, cursorx-20, cursory-8);
        bmf_black.DrawEx(g, "Menu", cursorx-23, cursory-8-bmf_black.lineHeight/2, Graphics.RIGHT|Graphics.VCENTER);

        cursorx = (Utils.GetScreenWidth()/2) + img_keypad.getWidth()/2 + 3;
        cursory = 116;
        g.drawLine(cursorx, cursory, cursorx+20, cursory-8);
        bmf_black.DrawEx(g, "Stats", cursorx+23, cursory-8-bmf_black.lineHeight/2, Graphics.LEFT|Graphics.VCENTER);

        cursorx = (Utils.GetScreenWidth()/2) + img_keypad.getWidth()/2 + 3;
        cursory = 132;
        g.drawLine(cursorx, cursory, cursorx+20, cursory-3);
        bmf_black.DrawEx(g, "Movement", cursorx+23, cursory-3-bmf_black.lineHeight/2, Graphics.LEFT|Graphics.VCENTER);

        cursorx = (Utils.GetScreenWidth()/2) - img_keypad.getWidth()/2 - 3;
        cursory = 201;
        g.drawLine(cursorx, cursory, cursorx-20, cursory+4);
        bmf_black.DrawEx(g, "Menu", cursorx-23, cursory+4-bmf_black.lineHeight/2, Graphics.RIGHT|Graphics.VCENTER);
        
        cursorx = (Utils.GetScreenWidth()/2) + img_keypad.getWidth()/2 + 3;
        cursory = 201;
        g.drawLine(cursorx, cursory, cursorx+20, cursory+4);
        bmf_black.DrawEx(g, "Pause", cursorx+23, cursory+4-bmf_black.lineHeight/2, Graphics.LEFT|Graphics.VCENTER);
      }
      break;

      case STATE_TAB_MOVE:
      {
        cursory = size_header*2 + 12;
        bmf_black.Draw(g, "Root Town ▶ Dungeon", 5, cursory);
        bmf_black.Draw(g, "Use the Chaos Gate.", 10, cursory+=bmf_black.lineHeight);

        bmf_black.Draw(g, "Dungeon ▶ Root Town", 5, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Use an Ocarina.", 10, cursory+=bmf_black.lineHeight);
      }
      break;

      case STATE_TAB_ITEMS:
      {
        cursory = size_header*2 + 12;
        bmf_black.Draw(g, "HP Recovery", 10, cursory);
        bmf_black.Draw(g, "Health Drink (50%)", 20, cursory+=bmf_black.lineHeight);
        bmf_black.Draw(g, "Healing Elixer (100%)", 20, cursory+=bmf_black.lineHeight);

        bmf_black.Draw(g, "SP Recovery", 10, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Mage's Soul (50%)", 20, cursory+=bmf_black.lineHeight);
        bmf_black.Draw(g, "Emperor's Soul (100%)", 20, cursory+=bmf_black.lineHeight);
        
        bmf_black.Draw(g, "Noble Wine:", 10, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Restores HP+SP.", 20, cursory+=bmf_black.lineHeight);

        bmf_black.Draw(g, "Antidote:", 10, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Poison Treatment.", 20, cursory+=bmf_black.lineHeight);

        bmf_black.Draw(g, "Restorative:", 10, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Curse Treatment.", 20, cursory+=bmf_black.lineHeight);

        bmf_black.Draw(g, "Resurrect:", 10, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Revive a player.", 20, cursory+=bmf_black.lineHeight);

        bmf_black.Draw(g, "Ocarina:", 10, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Move to Root Town.", 20, cursory+=bmf_black.lineHeight);
      }
      break;

      case STATE_TAB_SKILL:
      {
        cursory = size_header*2 + 12;
        bmf_black.Draw(g, "Attack Power UP", 10, cursory);
        bmf_black.Draw(g, "Ap Corv", 20, cursory+=bmf_black.lineHeight);

        bmf_black.Draw(g, "HP Recovery", 10, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Repth - One Player", 20, cursory+=bmf_black.lineHeight);
        bmf_black.Draw(g, "La Repth - Everyone", 20, cursory+=bmf_black.lineHeight);

        bmf_black.Draw(g, "Data Drain", 10, cursory+=bmf_black.lineHeight+5);
        bmf_black.Draw(g, "Use on Boss monsters to weaken them.", 20, cursory+=bmf_black.lineHeight);
        bmf_black.Draw(g, "Requirements Monster HP 50% Kite SP 100%", 20, cursory+=bmf_black.lineHeight);
      }
      break;
    
      default: break;
    }

    if (sagiri.input.IsKeyDown(new int[]{Sagiri.KEY_RIGHT, Sagiri.KEY_6}))
    {
      state_tab++;
      state_page = 0;
      if (state_tab > 3) state_tab = 0;
    }

    if (sagiri.input.IsKeyDown(new int[]{Sagiri.KEY_LEFT, Sagiri.KEY_4}))
    {
      state_tab--;
      state_page = 0;
      if (state_tab < 0) state_tab = 3;
    }

    if (sagiri.input.IsKeyDown(Sagiri.KEY_CENTER) || sagiri.input.IsKeyDown(Sagiri.KEY_RIGHT_SOFT))
    {
      sagiri.Set_Scene(new MainMenu());
    }
  }
  
}
